;
; sse_multiplies()
;
; To measure flop/sec

global fpu_mult
fpu_mult:
	push		ebp
	mov		ebp,esp
	push		eax
	push		ebx
	push		ecx
	mov		eax,[ebp+8]			; 1.000001
	mov		ebx,[ebp+12]			; pointer to float
	mov		ecx,[ebp+20]			; su3_vector *c

	fld		DWORD[ebp+8]
	fld		DWORD[ebp+8]
	
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1

	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1

	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1

	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1

	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1

	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1

	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1

	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1

	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1

	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1
	fmul		st0,st1

	fxch		st1
	fstp		DWORD[ebx]
	fstp		DWORD[ebx]
	jmp		here
	  
global sse_mult
sse_mult:
	push		ebp
	mov		ebp,esp
	push		eax
	push		ebx
	push		ecx
	mov		eax,[ebp+8]			; 1.000001
	mov		ebx,[ebp+12]			; pointer to float
	mov		ecx,[ebp+20]			; su3_vector *c

	movss		xmm0,[ebp+8]                    ; just over 1.0
	shufps		xmm0,xmm0,0x00			; 1.0, 1.0, 1.0, 1.0
	movaps		xmm1,xmm0

	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0

	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
		
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0

	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0

	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
		
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0

	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
	mulps		xmm1,xmm0
there:
	movss		[ebx],xmm1

here:	pop		ecx
	pop		ebx
	pop		eax
	mov		esp,ebp
	pop		ebp
	ret

